#!/bin/sh -e


if [ -z "$ARCH" ]; then
  ARCH=`dpkg --print-architecture`
fi

if [ -z "$ARCHT" ]; then
  case $ARCH in
  i386) ARCHT=i386-linux-gnu ;;
  amd64) ARCHT=x86_64-linux-gnu ;;
  *) echo "unknown arch" ; exit 1 ;;
  esac
fi

BPREFIX=`BPREFIX`
SONAME=`readlink $BPREFIX/lib/libfcl.so`
MTSONAME=`readlink $BPREFIX/lib/libfcl_mt.so`

rm -Rf ./work/lib.deb ./work/dev.deb

mkdir ./work/lib.deb ./work/dev.deb

# place files
mkdir -p ./work/lib.deb/usr/lib/$ARCHT ./work/dev.deb/usr/lib/$ARCHT ./work/dev.deb/usr/include/$ARCHT/fcl ./work/dev.deb/usr/share/man/man3
cp -p $BPREFIX/lib/$SONAME ./work/lib.deb/usr/lib/$ARCHT/$SONAME
cp -p $BPREFIX/lib/$MTSONAME ./work/lib.deb/usr/lib/$ARCHT/$MTSONAME
cp -p $BPREFIX/lib/libfcl.a $BPREFIX/lib/libfcl_mt.a \
      $BPREFIX/lib/libfcl_static.a $BPREFIX/lib/libfcl_mt_static.a \
    ./work/dev.deb/usr/lib/$ARCHT/
ln -s "$SONAME" ./work/dev.deb/usr/lib/$ARCHT/libfcl.so
ln -s "$MTSONAME" ./work/dev.deb/usr/lib/$ARCHT/libfcl_mt.so
cp -p $BPREFIX/include/fcl/* ./work/dev.deb/usr/include/$ARCHT/fcl/
cp -p ./man/*.3 ./work/dev.deb/usr/share/man/man3/

# place controls
VERSION=`head -1 ./CHANGELOG.TXT | tr -d -`
SIZELIB=`du -k -s ./work/lib.deb | awk '{print $1}'`
SIZEDEV=`du -k -s ./work/dev.deb | awk '{print $1}'`
if [ -n "$FCL_LIBC_DEPS" ]; then
  DEPS="$FCL_LIBC_DEPS"
else
  VER1=`dpkg-query -W -f='${Version}' libc6`
  DEPS="libc6 (>= $VER1)"
fi
if [ -n "$FCL_NAME_APPEND" ]; then
  NAMEA="-$FCL_NAME_APPEND"
else
  NAMEA=""
fi
mkdir ./work/lib.deb/DEBIAN ./work/dev.deb/DEBIAN
( cd ./work/lib.deb && md5deep -r -l usr) > ./work/lib.deb/DEBIAN/md5sums 2>> /dev/null
( cd ./work/dev.deb && md5deep -r -l usr) > ./work/dev.deb/DEBIAN/md5sums 2>> /dev/null
cat > ./work/lib.deb/DEBIAN/control <<EOF
Package: libfccl${NAMEA}
Version: $VERSION
Architecture: $ARCH
Maintainer: firk <firk@cantconnect.ru>
Installed-Size: $SIZELIB
Depends: $DEPS
Section: libs
Priority: optional
Multi-Arch: same
Homepage: https://dev.m1089.ru/fcl
Description: firk's Common C library
EOF
cat > ./work/dev.deb/DEBIAN/control <<EOF
Package: libfccl${NAMEA}-dev
Version: $VERSION
Architecture: $ARCH
Maintainer: firk <firk@cantconnect.ru>
Installed-Size: $SIZEDEV
Depends: libfccl${NAMEA} (>= $VERSION)
Section: libdevel
Priority: optional
Homepage: https://dev.m1089.ru/fcl
Description: firk's Common C library - development files
EOF

fakeroot dpkg-deb --build ./work/lib.deb ./work
fakeroot dpkg-deb --build ./work/dev.deb ./work

echo "DONE"
