#!/bin/sh -e

./config.sh "$@"
CCI charset/gen.c -o work/charsets-gen.o
LDI work/charsets-gen work/charsets-gen.o
echo "Generating: charset/charsets.lst -> work/charsets.inc"
./work/charsets-gen < charset/charsets.lst > work/charsets.inc 2> work/charsets-gen.log

export OBJDIR=work/obj
rm -Rf "$OBJDIR"
mkdir "$OBJDIR"
FCL_OPTS="-DTHREAD_LOCAL=" sh -e build-sub.sh
AR libfcl.a "$OBJDIR"/*.o
AR libfcl_static.a "$OBJDIR"/*.o

if grep -F FCL_WITH_SHARED work/config.h >> /dev/null; then
  rm -Rf "$OBJDIR"
  mkdir "$OBJDIR"
  FCL_OPTS="-fPIC -DTHREAD_LOCAL=" sh -e build-sub.sh
  LDI.SO2 libfcl.so 1 "$OBJDIR"/*.o
fi

if grep -F FCL_WITH_MT work/config.h >> /dev/null; then
  rm -Rf "$OBJDIR"
  mkdir "$OBJDIR"
  FCL_THREADS=1 FCL_OPTS="-DFCL_THREADS=1 -DTHREAD_LOCAL=__thread" sh -e build-sub.sh
  AR libfcl_mt.a "$OBJDIR"/*.o
  AR libfcl_mt_static.a "$OBJDIR"/*.o
  
  if grep -F FCL_WITH_SHARED work/config.h >> /dev/null; then
    rm -Rf "$OBJDIR"
    mkdir "$OBJDIR"
    FCL_THREADS=1 FCL_OPTS="-fPIC -DFCL_THREADS=1 -DTHREAD_LOCAL=__thread" sh -e build-sub.sh
    LDI.SO2 libfcl_mt.so 1 "$OBJDIR"/*.o
  fi
fi

HEADERS fcl *.h conio/*.h charset/charset.h
HEADERS fcl work/string.h work/types.h

rm -Rf "$OBJDIR"

