#!/bin/sh -e

rm -Rf work/*

cd config

cd types
echo "Generating: types.h" 1>&2
./gentypes.sh ../../work > ../../work/types.h
echo "Verifying: types.h" 1>&2
./chktypes.sh ../../work ../../work
cd ..
CCI opts-config.c -o ../work/opts-config.o
LDI ../work/opts-config ../work/opts-config.o
./../work/opts-config "$@" > ../work/config.h
./syslib/config.sh ../work syslib >> ../work/config.h
cp syslib/string.h ../work/string.h
if grep -F HAVE_EXPLICIT_BZERO ../work/config.h >> /dev/null; then
  grep -v -F "define FCL_EXPLICIT_BZERO" ../work/string.h > ../work/string.hh
  mv ../work/string.hh ../work/string.h
fi
if grep -F HAVE_STRLCPY ../work/config.h >> /dev/null; then
  grep -v -F "define FCL_STRLCPY" ../work/string.h > ../work/string.hh
  mv ../work/string.hh ../work/string.h
fi
if grep -F FCL_NO_STRERROR ../work/config.h > ../work/strerror.inc; then
  echo "strerror() caching disabled"
else
  grep -F FCL_STRERROR_STATIC ../work/config.h >> ../work/strerror.inc || true
  CCI errno-gen.c -o ../work/errno-gen.o
  LDI ../work/errno-gen ../work/errno-gen.o
  ./../work/errno-gen >> ../work/strerror.inc
fi
